//+------------------------------------------------------------------+
//|                                                functii utile.mqh |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2010
//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);
// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import
//example : int r = ShellExecuteW(0,NULL,"C:\\windows\\notepad.exe",NULL,NULL,5);
#import "shell32.dll"
int ShellExecuteW(int hwnd,const string Operation,const string File,const string Parameters,const string Directory,int ShowCmd);
#import
//+------------------------------------------------------------------+
//| EX5 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex5"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+

//returns the MqlRates struct for the k candlestick from right to left (from present to past)
MqlRates barInfo(const int k) {
   MqlRates rates[1];
   int r = CopyRates(NULL,0,k,1,rates);
   return rates[0];
}

//identifies the candlestick which is at the xCoordinate(in pixels) (xCoordinate taken from mouse, for example)
// if you click into the blank area in the right of the chart, the returned bar will be 0 (the first one).
int xToBar(const int xCoord) {
   int bar = 1 + ChartGetInteger(0,CHART_FIRST_VISIBLE_BAR) - 1.0*xCoord*ChartGetInteger(0,CHART_WIDTH_IN_BARS)/ChartGetInteger(0,CHART_WIDTH_IN_PIXELS);
   if (bar < 0) bar = 0;
   return bar;
}

//identifies the candlestick which is at the xCoordinate(in pixels) (xCoordinate taken from mouse, for example)
//and returns its MqlRates struct with info
MqlRates xToBarInfo(const int xCoord){
   MqlRates r = barInfo(xToBar(xCoord));
   return r;
}

//the same as above
//identifies the candlestick which is at the xCoordinate(in pixels) (xCoordinate taken from mouse, for example)
//only that it returns its datetime
datetime xToTime(const int xCoord) {
   MqlRates r = barInfo(xToBar(xCoord));
   return r.time;
}

//converts pixels into price. Pixels taken from mouse, for example.
//when yCoord is taken from mouse, because of yCoordinate being an int
//the exactness of price returned is dependant of zooming level. More zoom out => less exactness; more zoom in => more exactness.
double yToPrice(const double yCoord){
   double p = ChartGetDouble(0,CHART_PRICE_MAX) - yCoord*(ChartGetDouble(0,CHART_PRICE_MAX) - ChartGetDouble(0,CHART_PRICE_MIN))/ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS);
   return p;
}

void deleteObjectsByPrefix(const string Prefix){
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal(0,0)){
    string ObjName = ObjectName(0,i,0);
    if(StringSubstr(ObjName, 0, L) != Prefix) 
      { 
        i++; 
        continue;
      }
    ObjectDelete(0,ObjName);
  }
}
